RADIO_GET_STATUS = 0xC0
RADIO_WRITE_REGISTER = 0x18
RADIO_READ_REGISTER = 0x19
RADIO_WRITE_BUFFER = 0x1A
RADIO_READ_BUFFER = 0x1B
RADIO_SET_SLEEP = 0x84
RADIO_SET_STANDBY = 0x80
RADIO_SET_TX = 0x83
RADIO_SET_RX = 0x82
RADIO_SET_CAD = 0xC5
RADIO_SET_PACKETTYPE = 0x8A
RADIO_GET_PACKETTYPE = 0x03
RADIO_SET_RFFREQUENCY = 0x86
RADIO_SET_TXPARAMS = 0x8E
RADIO_SET_CADPARAMS = 0x88
RADIO_SET_BUFFERBASEADDRESS = 0x8F
RADIO_SET_MODULATIONPARAMS = 0x8B
RADIO_SET_PACKETPARAMS = 0x8C
RADIO_GET_RXBUFFERSTATUS = 0x17
RADIO_GET_PACKETSTATUS = 0x1D
RADIO_GET_RSSIINST = 0x1F
RADIO_SET_DIOIRQPARAMS = 0x8D
RADIO_GET_IRQSTATUS = 0x15
RADIO_CLR_IRQSTATUS = 0x97
RADIO_SET_REGULATORMODE = 0x96
RADIO_SET_AUTOFS = 0x9E
RADIO_SET_RANGING_ROLE = 0xA3

PACKET_TYPE_LORA = 0x01
PACKET_TYPE_RANGING = 0x02
PACKET_HEADER_EXPLICIT = 0x00
PACKET_HEADER_IMPLICIT = 0x80
PACKET_CRC_MODE_ON = 0x20
PACKET_CRC_MODE_OFF = 0x00
PACKET_IQ_INVERT = 0x00
PACKET_IQ_NORMAL = 0x40

XTAL_FREQ = 52000000

FREQ_STEP = XTAL_FREQ / 262144

RH_BROADCAST_ADDRESS = 0xFF
RH_FLAGS_ACK = 0x80
RH_FLAGS_RETRY = 0x40

MODE_MASK = 0xE0
CMD_STAT_MASK = 0x1C

IRQ1_DEF = (
    "RngSlaveReqDiscard",
    "RngMasterResultValid",
    "RngMasterTimeout",
    "RngMasterReqValid",
    "CadDone",
    "CadDetected",
    "RxTxTimeout",
    "AdvRngDone",
)

IRQ2_DEF = (
    "TxDone",
    "RxDone",
    "SyncWrdValid",
    "SyncWrdErr",
    "HeaderValid",
    "HeaderErr",
    "CrcErr",
    "RngSlaveResponseDone",
)

STATUS_MODE = {
    0: "N/A",
    1: "N/A",
    2: "STDBY_RC",
    3: "STDBY_XOSC",
    4: "FS",
    5: "Rx",
    6: "Tx",
}

STATUS_CMD = {
    0: "N/A",
    1: "Cmd Successful",
    2: "Data Available",
    3: "Timed-out",
    4: "Cmd Error",
    5: "Failure to Execute Cmd",
    6: "Tx Done",
}
